/**
 * Reception et affichage des donnees d'un telemetre a ultrasons simple Interface-Z
 * Receiving and displaying data from a Midi ultrasound rangefinder
 */
import promidi.*;
MidiIO midiIO;


void setup()
{
  midiIO = MidiIO.getInstance(this);
  println("<<<<<<<<< Ports Midi >>>>>>>>>");
  midiIO.printDevices();
  midiIO.openInput(0,0);  
  
  PFont fontA = loadFont("CourierNew36.vlw");
  textFont(fontA, 36);

  size(256, 256, P3D);
  background(0);
  noStroke();

}

int[] valeur = new int[2]; 
int telemetre;

// Reception des donnees des capteurs.
// Receiving sensors data.
void controllerIn(Controller controller, int device, int channel){
  int numero = controller.getNumber();

  if (numero == 2){
    valeur[0] = controller.getValue();
  }    
  if (numero == 3) {
    valeur[1] = controller.getValue();
    telemetre = valeur[1] + (valeur[0] << 7);   
  }
    println(telemetre);
}

/* Affichage des donnees du capteur.
 * Displaying sensor data.
 */
 
void draw()
{
  background(0);
  fill(255);
  color coul_asc = color(212, 255, 106);
  color coul_barre = color(255, 50, 255); 
  
  fill(coul_asc);
  rect(10, 0, 30, 256); 

  fill(coul_barre);
  if (telemetre < 3500) {
  rect(10, 254-(telemetre * 0.073), 30, 2); 
  }
  if (telemetre >= 3500) {
  rect(10, 0, 30, 2);
  }
   
  fill(255);
  text("Tlmtre", 50, 50);
  text("Midi", 80, 90);
  text(telemetre, 80, 150);
}


